#ifndef __UENC_H__
#define __UENC_H__


#include <sys/types.h>

u_int32_t crc32(u_int32_t crc, u_int8_t * buf, u_int32_t len);

/* echo = 0 - no echo,1 - echo, 2 - '*' echo */ 
int ucrp_select(char * buf, int len, int echo, int wait);
int ucrp_history_read_buf(FILE * fhst, char * rbuf, int rsize);
/* history record encrypt/decrypt */

#undef UCRP_HISTORY_SIMPLE_CODING

#define UCRP_HIST_NAME_LEN     32 	/* history name length */
#define UCRP_HIST_COP_LEN (512-32-sizeof(u_int32_t))	/* history */

typedef struct {
    u_int8_t name[UCRP_HIST_NAME_LEN];		/* header name */	
    u_int8_t copyright[UCRP_HIST_COP_LEN];	/* copyright message */
    u_int32_t crc32;				/* file CRC */
    u_int8_t reserved[256];		/* reseded field */
} UCRP_HISTORY_HEADER;

int ucrp_history_de(UCRP_HISTORY_HEADER * header, char * buf, int len, int size);
int ucrp_history_en(UCRP_HISTORY_HEADER * header, char * buf, int len, int size);

/* ucrpstr */
char * ucrp_msg(int num);


#endif							/* __UENC_H__ */
